﻿using Syncfusion.Windows.Tools.Controls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DockingManagerSizetoContent
{
    /// <summary>
    /// Interaction logic for ButtonsView.xaml
    /// </summary>
    public partial class ButtonsView : UserControl
    {
        private bool IsOpen = false;

        private bool InEdition = false;
        public ButtonsView()
        {
            InitializeComponent();
            Loaded += ButtonsView_Loaded;
        }

        private void ButtonsView_Loaded(object sender, RoutedEventArgs e)
        {
            Binding bind = new Binding();
            bind.Path = new PropertyPath("Width");
            bind.Source = rootObject;
            bind.Mode = BindingMode.TwoWay;
            SetBinding(DockingManager.DesiredWidthInDockedModeProperty, bind);
        }

        private void DisplayListView(bool Open)
        {
            Storyboard sb;
            if (Open)
                sb = this.FindResource("StoryboardOpenListView") as Storyboard;
            else
                sb = this.FindResource("StoryboardCloseListView") as Storyboard;
            sb.Begin();
            IsOpen = Open;

        }

        private void Button_MouseEnter(object sender, MouseEventArgs e)
        {
            // If it's not open, we open it
            if (!IsOpen)
                DisplayListView(true);
        }

        private void rootObject_MouseLeave(object sender, MouseEventArgs e)
        {
            // If it's open, we close it
            if (IsOpen && !InEdition)
                DisplayListView(false);
        }

        private void lvSelector_PreviewMouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
            // By clicking the right mouse button a context menu will be shown, so
            // in order to keep the listview opened, we set InEdition = true
            InEdition = true;
        }

        private void lvSelector_ContextMenuOpening(object sender, ContextMenuEventArgs e)
        {
            if (!InEdition)
                e.Handled = true;
        }

    }
}
